package be.iminds.ilabt.jfed.restapi.dao;

import be.iminds.ilabt.jfed.restapi.JFedRestApiConfiguration;
import be.iminds.ilabt.jfed.util.IOUtils;
import io.dropwizard.testing.junit.DropwizardAppRule;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;

/**
 * TestPostgresDB
 */
public class TestPostgresDB {
    private Connection con;
//    private String dropScript;
    private String clearScript;
//    private String createScript;
    private String fillScript;

    public TestPostgresDB(DropwizardAppRule<JFedRestApiConfiguration> RULE) {
        assert RULE != null;
        try {
//            dropScript = IOUtils.resourceToString("drop_tables.sql", TestPostgresDB.class);
            clearScript = IOUtils.resourceToString("clear_tables.sql", TestPostgresDB.class);
//            createScript = IOUtils.resourceToString("fedmon_structure_dump.sql", TestPostgresDB.class);
            fillScript = IOUtils.resourceToString("fill_tables.sql", TestPostgresDB.class);

            //delete and recreate test DB
            Properties connectionProps = new Properties();
            connectionProps.put("user", RULE.getConfiguration().getDataSourceFactory().getUser());
            connectionProps.put("password", RULE.getConfiguration().getDataSourceFactory().getPassword());

            con = DriverManager.getConnection(
                    RULE.getConfiguration().getDataSourceFactory().getUrl(),
                    connectionProps);
            assert con != null;
        } catch (Exception e) {
            throw new RuntimeException("Exception while setting up test DB helper", e);
        }
    }

//    public void dropAllTables() throws SQLException {
//        assert con != null;
//        Statement stmt = con.createStatement();
//        stmt.execute(dropScript);
//        stmt.close();
//    }
    public void clearAllTables() throws SQLException {
        assert con != null;
        Statement stmt = con.createStatement();
        stmt.execute(clearScript);
        stmt.close();
    }
//    public void createAllTables() throws SQLException {
//        assert con != null;
//        Statement stmt = con.createStatement();
//        stmt.execute(createScript);
//        stmt.close();
//    }
    public void fillAllTables() throws SQLException {
        assert con != null;
        Statement stmt = con.createStatement();
        stmt.execute(fillScript);
        stmt.close();
    }

    public void executeStatement(String statementString) throws SQLException {
        assert con != null;
        Statement stmt = con.createStatement();
        stmt.execute(statementString);
        stmt.close();
    }

//    /**
//     * DROP all tables, and set complete DB structure again.
//     * Fill all tables with initial values.
//     * */
//    public void recreateDB() throws SQLException {
//        assert con != null;
//        dropAllTables();
//        createAllTables();
//        fillAllTables();
//    }

    /**
     * Clear all tables, leaving DB structure as is.
     * Then fill all tables with initial values.
     * */
    public void refillDB() throws SQLException {
        assert con != null;
        clearAllTables();
        fillAllTables();
    }

    public void close() throws SQLException {
        assert con != null;
        con.close();
        con = null;
    }
}
